CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

obj
  pcm : "PCM_020.spin"

pub main

pcm.Start(31, 100)     'pin 31, 1 second has 100 divisions


'mario theme intro using tenor version of sine sample
waitcnt(clkfreq + cnt)
pcm.PlayNote(1, pcm#tE4, 0, 0, 10, 7)
waitcnt(clkfreq / 8 + cnt)

pcm.PlayNote(1, pcm#tE4, 0, 0, 10, 7)     
waitcnt(clkfreq / 4 + cnt)

pcm.PlayNote(1, pcm#tE4, 0, 0, 10, 7)
waitcnt(clkfreq / 4 + cnt)

pcm.PlayNote(1, pcm#tC4, 0, 0, 10, 7)
waitcnt(clkfreq / 8 + cnt)

pcm.PlayNote(1, pcm#tE4, 0, 0, 10, 7)
waitcnt(clkfreq / 4 + cnt)

pcm.PlayNote(1, pcm#tG4, 0, 0, 10, 7)
waitcnt(clkfreq / 2 + cnt)

pcm.PlayNote(1, pcm#tG3, 0, 0, 10, 7)



    
'same tune, gradual decrease of bit-quality, last note is 1-bit (or a squarewave)
waitcnt(clkfreq + cnt)
pcm.PlayNote(1, pcm#tE4, 0, 22, 10, 7)
waitcnt(clkfreq / 8 + cnt)

pcm.PlayNote(1, pcm#tE4, 0, 23, 10, 7)     
waitcnt(clkfreq / 4 + cnt)

pcm.PlayNote(1, pcm#tE4, 0, 24, 10, 7)
waitcnt(clkfreq / 4 + cnt)

pcm.PlayNote(1, pcm#tC4, 0, 25, 10, 7)
waitcnt(clkfreq / 8 + cnt)

pcm.PlayNote(1, pcm#tE4, 0, 26, 10, 7)
waitcnt(clkfreq / 4 + cnt)

pcm.PlayNote(1, pcm#tG4, 0, 27, 10, 7)
waitcnt(clkfreq / 2 + cnt)

pcm.PlayNote(1, pcm#tG3, 0, 28, 10, 7)





'same tune, squarewave (even though it is the sine sample, it's implemented as 1-bit)
waitcnt(clkfreq + cnt)
pcm.PlayNote(1, pcm#tE4, 0, 29, 10, 7)
waitcnt(clkfreq / 8 + cnt)

pcm.PlayNote(1, pcm#tE4, 0, 29, 10, 7)     
waitcnt(clkfreq / 4 + cnt)

pcm.PlayNote(1, pcm#tE4, 0, 29, 10, 7)
waitcnt(clkfreq / 4 + cnt)

pcm.PlayNote(1, pcm#tC4, 0, 29, 10, 7)
waitcnt(clkfreq / 8 + cnt)

pcm.PlayNote(1, pcm#tE4, 0, 29, 10, 7)
waitcnt(clkfreq / 4 + cnt)

pcm.PlayNote(1, pcm#tG4, 0, 29, 10, 7)
waitcnt(clkfreq / 2 + cnt)

pcm.PlayNote(1, pcm#tG3, 0, 29, 10, 7)





'same tune, bass version of triangle wave. Volume starts low and increases. bit quality is blasted down on last note
waitcnt(clkfreq + cnt)
pcm.PlayNote(1, pcm#tE4, 6, 0, 10, 1)
waitcnt(clkfreq / 8 + cnt)

pcm.PlayNote(1, pcm#tE4, 5, 0, 10, 1)     
waitcnt(clkfreq / 4 + cnt)

pcm.PlayNote(1, pcm#tE4, 4, 0, 10, 1)
waitcnt(clkfreq / 4 + cnt)

pcm.PlayNote(1, pcm#tC4, 3, 0, 10, 1)
waitcnt(clkfreq / 8 + cnt)

pcm.PlayNote(1, pcm#tE4, 2, 0, 10, 1)
waitcnt(clkfreq / 4 + cnt)

pcm.PlayNote(1, pcm#tG4, 1, 0, 20, 1)
waitcnt(clkfreq / 2 + cnt)

pcm.PlayNote(1, pcm#tG3, 0, 0, 20, 1)
waitcnt(clkfreq / 25 + cnt)
pcm.PlayNote(1, pcm#tG3, 0, 21, 20, 1)
waitcnt(clkfreq / 25 + cnt)
pcm.PlayNote(1, pcm#tG3, 0, 22, 20, 1)
waitcnt(clkfreq / 25 + cnt)
pcm.PlayNote(1, pcm#tG3, 0, 23, 20, 1)
waitcnt(clkfreq / 25 + cnt)
pcm.PlayNote(1, pcm#tG3, 0, 24, 20, 1)
waitcnt(clkfreq / 25 + cnt)
pcm.PlayNote(1, pcm#tG3, 0, 25, 20, 1)
waitcnt(clkfreq / 25 + cnt)
pcm.PlayNote(1, pcm#tG3, 0, 26, 20, 1)
waitcnt(clkfreq / 25 + cnt)
pcm.PlayNote(1, pcm#tG3, 0, 27, 20, 1)
waitcnt(clkfreq / 25 + cnt)
pcm.PlayNote(1, pcm#tG3, 0, 28, 20, 1)
waitcnt(clkfreq / 25 + cnt)
pcm.PlayNote(1, pcm#tG3, 0, 29, 50, 1)



'Demonstrates the sound difference of a triangle wave and a square wave at different frequencies.
'This shows that it is harder to hear the difference at higher frequencies, I know it's subjective, but I think
'others would agree with the results.
waitcnt(clkfreq + cnt)
pcm.PlayNote(1, pcm#tG1, 0, 0, 50, 10)
waitcnt(clkfreq + cnt)
pcm.PlayNote(1, pcm#tG1, 0, 29, 50, 10)

waitcnt(clkfreq + cnt)
pcm.PlayNote(1, pcm#tG2, 0, 0, 50, 10)
waitcnt(clkfreq + cnt)
pcm.PlayNote(1, pcm#tG2, 0, 29, 50, 10)

waitcnt(clkfreq + cnt)
pcm.PlayNote(1, pcm#tG3, 0, 0, 50, 10)
waitcnt(clkfreq + cnt)
pcm.PlayNote(1, pcm#tG3, 0, 29, 50, 10)

waitcnt(clkfreq + cnt)
pcm.PlayNote(1, pcm#tG4, 0, 0, 50, 10)
waitcnt(clkfreq + cnt)
pcm.PlayNote(1, pcm#tG4, 0, 29, 50, 10)

waitcnt(clkfreq + cnt)
pcm.PlayNote(1, pcm#tG5, 0, 0, 50, 10)
waitcnt(clkfreq + cnt)
pcm.PlayNote(1, pcm#tG5, 0, 29, 50, 10)

waitcnt(clkfreq + cnt)
pcm.PlayNote(1, pcm#tG6, 0, 0, 50, 10)
waitcnt(clkfreq + cnt)
pcm.PlayNote(1, pcm#tG6, 0, 29, 50, 10) 
