CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

obj
  pcm : "PCM_022.spin"

pub main

pcm.Start(31, 100)     'pin 31, 1 second has 100 divisions


'Examples of DownNote and UpNote functions

'Demo of DownNote using various wave shapes
pcm.DownNote (pcm#tE3, 1, 32, 200, 30)
waitcnt(clkfreq  + cnt)
pcm.DownNote (pcm#tE3, 2, 32, 200, 30)
waitcnt(clkfreq  + cnt)
pcm.DownNote (pcm#tE3, 3, 32, 200, 30)
waitcnt(clkfreq  + cnt)
pcm.DownNote (pcm#tE3, 4, 32, 200, 30)
waitcnt(clkfreq  + cnt)
pcm.DownNote (pcm#tE3, 5, 32, 200, 30)
waitcnt(clkfreq  + cnt)
pcm.DownNote (pcm#tE3, 6, 32, 200, 30)
waitcnt(clkfreq  + cnt)
pcm.DownNote (pcm#tE3, 7, 32, 200, 30)
waitcnt(clkfreq  + cnt)

waitcnt(clkfreq + cnt)

'Demo of DownNote going through a C major scale
pcm.DownNote (pcm#tC3, 2, 32, 200, 30)
waitcnt(clkfreq  + cnt)
pcm.DownNote (pcm#tD3, 2, 32, 200, 30)
waitcnt(clkfreq  + cnt)
pcm.DownNote (pcm#tE3, 2, 32, 200, 30)
waitcnt(clkfreq  + cnt)
pcm.DownNote (pcm#tF3, 2, 32, 200, 30)
waitcnt(clkfreq  + cnt)
pcm.DownNote (pcm#tG3, 2, 32, 200, 30)
waitcnt(clkfreq  + cnt)
pcm.DownNote (pcm#tA3, 2, 32, 200, 30)
waitcnt(clkfreq  + cnt)
pcm.DownNote (pcm#tB3, 2, 32, 200, 30)
waitcnt(clkfreq  + cnt)
pcm.DownNote (pcm#tC4, 2, 32, 200, 30)
waitcnt(clkfreq  + cnt)

waitcnt(clkfreq + cnt)  

'Demo of DownNote with different range lengths
pcm.DownNote (pcm#tE3, 7, 8, 200, 30)
waitcnt(clkfreq  + cnt)
pcm.DownNote (pcm#tE3, 7, 16, 200, 30)
waitcnt(clkfreq  + cnt)
pcm.DownNote (pcm#tE3, 7, 32, 200, 30)
waitcnt(clkfreq  + cnt)
pcm.DownNote (pcm#tE3, 7, 64, 200, 30)
waitcnt(clkfreq  + cnt)

waitcnt(clkfreq + cnt)  

'Demo of DownNote with different hold values
pcm.DownNote (pcm#tE3, 7, 64, 500, 30)
waitcnt(clkfreq  + cnt)
pcm.DownNote (pcm#tE3, 7, 64, 200, 30)
waitcnt(clkfreq  + cnt)
pcm.DownNote (pcm#tE3, 7, 64, 100, 30)
waitcnt(clkfreq  + cnt)
pcm.DownNote (pcm#tE3, 7, 64, 20, 30)
waitcnt(clkfreq  + cnt)

waitcnt(clkfreq + cnt)  

'Demo of DownNote with different end durations
pcm.DownNote (pcm#tE3, 7, 64, 200, 15)
waitcnt(clkfreq  + cnt)
pcm.DownNote (pcm#tE3, 7, 64, 200, 30)
waitcnt(clkfreq  + cnt)
pcm.DownNote (pcm#tE3, 7, 64, 200, 50)
waitcnt(clkfreq  + cnt)
pcm.DownNote (pcm#tE3, 7, 64, 200, 100)
waitcnt(clkfreq  + cnt)

waitcnt(clkfreq * 2 + cnt)  




'Demo of UpNote using various wave shapes  
pcm.UpNote (pcm#tE3, 1, 32, 200, 30)
waitcnt(clkfreq  + cnt)
pcm.UpNote (pcm#tE3, 2, 32, 200, 30)
waitcnt(clkfreq  + cnt)
pcm.UpNote (pcm#tE3, 3, 32, 200, 30)
waitcnt(clkfreq  + cnt)
pcm.UpNote (pcm#tE3, 4, 32, 200, 30)
waitcnt(clkfreq  + cnt)
pcm.UpNote (pcm#tE3, 5, 32, 200, 30)
waitcnt(clkfreq  + cnt)
pcm.UpNote (pcm#tE3, 6, 32, 200, 30)
waitcnt(clkfreq  + cnt)
pcm.UpNote (pcm#tE3, 7, 32, 200, 30)
waitcnt(clkfreq  + cnt)

waitcnt(clkfreq + cnt)

'Demo of UpNote going through a C major scale
pcm.UpNote (pcm#tC3, 2, 32, 200, 30)
waitcnt(clkfreq  + cnt)
pcm.UpNote (pcm#tD3, 2, 32, 200, 30)
waitcnt(clkfreq  + cnt)
pcm.UpNote (pcm#tE3, 2, 32, 200, 30)
waitcnt(clkfreq  + cnt)
pcm.UpNote (pcm#tF3, 2, 32, 200, 30)
waitcnt(clkfreq  + cnt)
pcm.UpNote (pcm#tG3, 2, 32, 200, 30)
waitcnt(clkfreq  + cnt)
pcm.UpNote (pcm#tA3, 2, 32, 200, 30)
waitcnt(clkfreq  + cnt)
pcm.UpNote (pcm#tB3, 2, 32, 200, 30)
waitcnt(clkfreq  + cnt)
pcm.UpNote (pcm#tC4, 2, 32, 200, 30)
waitcnt(clkfreq  + cnt)

waitcnt(clkfreq + cnt)

'Demo of UpNote with different range lengths
pcm.UpNote (pcm#tE3, 7, 8, 200, 30)
waitcnt(clkfreq  + cnt)
pcm.UpNote (pcm#tE3, 7, 16, 200, 30)
waitcnt(clkfreq  + cnt)
pcm.UpNote (pcm#tE3, 7, 32, 200, 30)
waitcnt(clkfreq  + cnt)
pcm.UpNote (pcm#tE3, 7, 64, 200, 30)
waitcnt(clkfreq  + cnt)

waitcnt(clkfreq + cnt)

'Demo of UpNote with different hold values 
pcm.UpNote (pcm#tE3, 7, 64, 500, 30)
waitcnt(clkfreq  + cnt)
pcm.UpNote (pcm#tE3, 7, 64, 200, 30)
waitcnt(clkfreq  + cnt)
pcm.UpNote (pcm#tE3, 7, 64, 100, 30)
waitcnt(clkfreq  + cnt)
pcm.UpNote (pcm#tE3, 7, 64, 20, 30)
waitcnt(clkfreq  + cnt)

waitcnt(clkfreq + cnt)

'Demo of UpNote with different end durations
pcm.UpNote (pcm#tE3, 7, 64, 200, 15)
waitcnt(clkfreq  + cnt)
pcm.UpNote (pcm#tE3, 7, 64, 200, 30)
waitcnt(clkfreq  + cnt)
pcm.UpNote (pcm#tE3, 7, 64, 200, 50)
waitcnt(clkfreq  + cnt)
pcm.UpNote (pcm#tE3, 7, 64, 200, 100)
waitcnt(clkfreq  + cnt)
       